package ovh.gasser.newshapes.shapes;

import ovh.gasser.newshapes.ShapeVisitor;
import ovh.gasser.newshapes.attributes.SelectionAttributes;

import java.awt.*;

public class SCircle extends AbstractShape {

    private int radius;

    private SCircle(int x, int y, int radius) {
        super(new Rectangle(x, y, radius, radius));
        this.radius = radius;
    }

    @Override
    public void accept(ShapeVisitor visitor) {
        visitor.visitCircle(this);
    }

    public int getRadius() {
        return radius;
    }

    public static SCircle create(int x, int y, int radius) {
        var circle = new SCircle(x, y, radius);
        circle.addAttributes(new SelectionAttributes());
        return circle;
    }
}
